import pygame
from . import files
from . import video
from . import shader
from . import models
from . import roc_main
from . import roc_engine
from . import config
from . import ui

base_engine = roc_engine.base_engine

def init2d():
	init(videoinit=video.init2d)
	
def init3d():
	init(videoinit=video.init3d)
	
def init(videoinit):
	pygame.init()
	files.init()
	config.init()
	shader.init()

	size = width, height = (1600,1200)
	size = width, height = (1024,768)

	video.set_res(size)
	videoinit()
	video.enable_vsync()
	
	models.init()
	ui.init()
	
def set_engine(new_engine):
	roc_main.set_engine(new_engine)

def get_engine():
	return roc_main.get_engine()

def set_timer(new_timer):
	roc_main.set_timer(new_timer)

def get_timer():
	return roc_main.get_timer()


def main():
	roc_main.mainloop()
